#!/bin/bash
#* Licensed Materials - Property of IBM
#*
#* OCO Source Materials
#*
#* (C) Copyright IBM Corp. 2011, 2012 All Rights Reserved
#*
# hbacheck.sh
#   version: 2.4.2 [09/28/2012]
#   author:  csky
#
let online=0
printf "%-7s %12s  %20s  %12s  %9s   %s\n" "HBA" "Port ID" "Port Name" "State" "Speed" "Type"
for fchba in $(ls -1 /sys/class/fc_host)
do
        hbapname=$(cat /sys/class/fc_host/$fchba/port_name)
        hbapid=$(cat /sys/class/fc_host/$fchba/port_id)
        hbastate=$(cat /sys/class/fc_host/$fchba/port_state)
        hbaspeed=$(cat /sys/class/fc_host/$fchba/speed)
        hbatype=$(cat /sys/class/fc_host/$fchba/symbolic_name)
        echo "-------------------------------------------------------------------------------------------------------"
        printf "%-7s %12s  %20s  %12s  %9s   %s\n" $fchba $hbapid $hbapname "$hbastate" "$hbaspeed" "$hbatype"
        if [ "$hbastate" = "Online" ]
        then
                let online=online+1
        fi
        if [ -z "$hosts" ]
        then
                hosts=$fchba
        else
                hosts="$hosts,$fchba"
        fi
        echo "-------------------------------------------------------------------------------------------------------"
        printf "%22s  %12s  %20s  %13s\n" "Remote Port" "RPort ID" "RPort Name" "RPort State"
        for rport in $(ls -1 -d /sys/class/fc_host/$fchba/device/rport*)
        do
                comp=$(echo $rport | cut -d / -f 7)
                addr=$rport/fc_remote_ports/$comp
                rportid=$(cat $addr/port_id)
                rportname=$(cat $addr/port_name)
                rstate=$(cat $addr/port_state)
                printf "%22s  %12s  %20s  %13s\n" $comp $rportid $rportname "$rstate"
        done
done
if [ "$online" = "0" ]
then
        echo "No host-side HBA ports are Online!"
        exit 1
fi
if [ -z "$hosts" ]
then
        echo "This endpoint does not appear to be attached to a Fibre Channel network. No entries in /sys/class/fc_host. Exiting."
        exit 1
fi

exit 0
